﻿using System;
using System.Windows;
using System.IO;

namespace LinearEq
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            myControl.UC = this;
            myControl.SetUC1();
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            myControl.CalExe();
        }

        private void MenuItem2_Click(object sender, RoutedEventArgs e)
        {
            int i; int j;
            int N = Convert.ToInt32(TextBox1.Text);

            String OutText = "LinearEq\r\n";
            OutText = OutText + "項目\t記号\t値\t単位\r\n";
            OutText = OutText + "連立数\tN\t" + TextBox1.Text + "\t元\r\n\r\n";

            for (j = 0; j < N + 2; j++)
            {
                OutText = OutText + myControl.dataGridView1.Columns[j].HeaderText + "\t";
            }
            OutText = OutText + "\r\n";
           
            for (i = 0; i < N+2; i++)
            {
                for (j = 0; j < N+2; j++)
                {
                    OutText = OutText + myControl.dataGridView1.Rows[ i].Cells[j].Value + "\t";
                }
                OutText = OutText + "\r\n";
            }

            if (myControl.saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (StreamWriter outfile = new StreamWriter(myControl.saveFileDialog1.FileName))
                {
                    outfile.Write(OutText);
                }
            }

        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
            this.WindowState = WindowState.Normal;
        }


        private void Button2_Click(object sender, RoutedEventArgs e)
        {
            myControl.SetUC2();
        }

        private void MenuItem3_Click(object sender, RoutedEventArgs e)
        {
            int i; int j;
            String[,] HData = new String[12, 12];

            if (myControl.openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (Microsoft.VisualBasic.FileIO.TextFieldParser MyReader = new Microsoft.VisualBasic.FileIO.TextFieldParser(myControl.openFileDialog1.FileName))
                {
                    MyReader.TextFieldType = Microsoft.VisualBasic.FileIO.FieldType.Delimited;
                    MyReader.SetDelimiters("\t");
                    String[] currentRow;
                    for (i = 0; i < 4; i++)
                    {
                        currentRow = MyReader.ReadFields();
                        if (currentRow != null)
                        {
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                HData[i, j] = currentField;
                                if (j < 4) { j = j + 1; }
                            }
                        }
                    }

                    if (HData[0, 0] == "LinearEq")
                    {
                        int N = Convert.ToInt32(HData[2, 2]);
                        String[,] RCData = new String[N, N+3];

                        for (i = 0; i < N; i++)
                        {
                            currentRow = MyReader.ReadFields();
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                RCData[i, j] = currentField;
                                if (j < N+2) { j = j + 1; }
                            }
                        }

                        TextBox1.Text = HData[2, 2];
                        myControl.SetUC2();
                        for (i = 0; i < N; i++)
                        {
                            for (j = 1; j < N + 2; j++)
                            {
                                myControl.dataGridView1.Rows[ i].Cells[j].Value = RCData[i, j];
                            }
                        }
                    }
                    else
                    {
                        System.Windows.MessageBox.Show("ファイル形式が異なります！！");
                    }
                }
            }
        }
    }
}
