﻿using System;
using System.Windows.Forms;

namespace LinearEq
{
    public partial class UserControl1 : UserControl
    {
        public MainWindow UC;
        public UserControl1()
        {
            InitializeComponent();
        }

        public void SetUC1()
        {
            int N = 0;
            N = Convert.ToInt32(UC.TextBox1.Text);

            dataGridView1.RowCount = N + 3;
            dataGridView1.ColumnCount = N + 2;
            int i;
            for (i = 0; i < N; i++)
            {
                dataGridView1.Columns[1 + i].HeaderText = "Ai" + Convert.ToString(i + 1);
                dataGridView1.Rows[i].Cells[0].Value = "i=" + Convert.ToString(i + 1);
                dataGridView1.Rows[N].Cells[1 + i].Value = "X" + Convert.ToString(i + 1);
            }
            dataGridView1.Columns[1 + N].HeaderText = "Bi";
            dataGridView1.Rows[N + 1].Cells[0].Value = "解";

            dataGridView1.Rows[0].Cells[1].Value = "1";
            dataGridView1.Rows[0].Cells[2].Value = "2";
            dataGridView1.Rows[0].Cells[3].Value = "4";
            dataGridView1.Rows[0].Cells[4].Value = "1.2";
            dataGridView1.Rows[0].Cells[5].Value = "1";

            dataGridView1.Rows[1].Cells[1].Value = "4";
            dataGridView1.Rows[1].Cells[2].Value = "1";
            dataGridView1.Rows[1].Cells[3].Value = "8";
            dataGridView1.Rows[1].Cells[4].Value = "4.5";
            dataGridView1.Rows[1].Cells[5].Value = "5";

            dataGridView1.Rows[2].Cells[1].Value = "7";
            dataGridView1.Rows[2].Cells[2].Value = "9";
            dataGridView1.Rows[2].Cells[3].Value = "10";
            dataGridView1.Rows[2].Cells[4].Value = "8.9";
            dataGridView1.Rows[2].Cells[5].Value = "2";

            dataGridView1.Rows[3].Cells[1].Value = "8.2";
            dataGridView1.Rows[3].Cells[2].Value = "4.2";
            dataGridView1.Rows[3].Cells[3].Value = "-5.6";
            dataGridView1.Rows[3].Cells[4].Value = "-8.1";
            dataGridView1.Rows[3].Cells[5].Value = "4.5";
        }

        public void SetUC2()
        {
            int N=0;
            if (UC.TextBox1.Text != "")
            {
                 N = Convert.ToInt32(UC.TextBox1.Text);
            }

            dataGridView1.RowCount = N +3;
            dataGridView1.ColumnCount = N + 2;

            int i; int j;
            for (i = 0; i < N+3; i++)
            {
                for (j = 0; j < N+2; j++)
                {
                    dataGridView1.Rows[i].Cells[j].Value = "";
                }
            }

            for (i = 0; i < N; i++)
            {
                dataGridView1.Columns[1+i].HeaderText = "Ai" + Convert.ToString(i+1);
                dataGridView1.Rows[i].Cells[0].Value = "i=" + Convert.ToString(i + 1);
                dataGridView1.Rows[N].Cells[1+i].Value = "X" + Convert.ToString(i + 1);
            }
            dataGridView1.Columns[1 + N].HeaderText = "Bi";
            dataGridView1.Rows[N+1].Cells[0].Value = "解" ;
        }

        public void CalExe()
        {
            int N = Convert.ToInt32(UC.TextBox1.Text);
            double[,] A = new double[N+1, N+1];//A[i,j]
            double[] B = new double[N+1];//B[i]
            double[] X = new double[N+1];//X[j]

            int i, j, k;
            for (i = 0; i < N; i++)
            {
                if ((String)dataGridView1.Rows[i].Cells[N + 1].Value == "")
                {B[i + 1] = 0;}
                else
                { B[i + 1] = Convert.ToDouble(dataGridView1.Rows[i].Cells[N + 1].Value);}
                for (j = 0; j < N; j++)
                {
                    if ((String)dataGridView1.Rows[i].Cells[j + 1].Value == "")
                    { A[i + 1, j + 1] = 0; }
                    else
                    { A[i + 1, j + 1] = Convert.ToDouble(dataGridView1.Rows[i].Cells[j + 1].Value); }
                }
            }

            double Akk, Aik, SX;
            for (k = 1; k <= N; k++)//Aij消去操作の繰り返し
            {
                for (i = k + 1; i <= N; i++)//連立数分の繰り返し計算
                {
                    Akk = A[k,k];
                    Aik = A[i,k];
                    B[i] = B[i] * Akk - Aik * B[k];//(6.2)式の計算
                    for (j = 1; j <= N; j++)//(6.1)式の計算
                    {
                        A[i,j] = A[i,j] * Akk - Aik * A[k,j];
                    }
                }          
            }
            if (A[N, N] != 0)
            {
                X[N] = B[N] / A[N, N];//(7.1)式の計算
                for (k = N - 1; k >= 1; k--)//Xjを求める計算の繰り返し
                {
                    SX = 0;
                    for (j = k + 1; j <= N; j++)
                    {
                        SX = SX + A[k, j] * X[j];
                    }
                    X[k] = (B[k] - SX) / A[k, k];//(8.1)式の計算
                }

                for (j = 1; j <= N; j++)
                {
                    dataGridView1.Rows[N + 1].Cells[j].Value = Convert.ToString(X[j]);
                }
            }
            else
            { MessageBox.Show("計算できません！！"); }
        }
    }
}
